## o-saft 19.01.19

=== t/Makefile ===
#! /usr/bin/make -rRf
#?
#? NAME
#?      Makefile        - makefile for testing O-Saft
#?
#? SYNOPSYS
#?      make [options] [target] [...]
#?
#? DESCRIPTION
#?      Makefile containing general testing targets for O-Saft project.
#?
#? LIMITATIONS
#?      Requires GNU Make > 2.0.
#?
# HACKER's INFO
#       For details please see
#           ../Makefile  ../Makefile.help  Makefile.template
#
#    Naming conventions for t/Makefile*
#       * macro names have the prefix  TEST.
#       * target names for public use have the prefix  test.
#       * individual, special targets have the prefix  test  (exceptions exist)
#
#    Special macros in t/Makefile*
#       ALL.includes    - list of Makefiles
#       ALL.inc.type    - type of tests (should be suffix of Makefile's name)
#       ALL.help.test   - list of documentation (help) texts
#       _SID.TYPE       - version number
#       _MYSELF.TYPE    - name of current file
#       HELP.TYPE       - documentation (help) text for the corresponding file
#       HELP.TYPE.all   - list of all targets for the corresponding file
#       HELP.TYPE.internal  - some more documentation (help) text
#           where  TYPE  is the suffix of the Makefile's filename
#
#    Special targets for documentation (help) in t/Makefile*
#       help.test.%     - print individual documentation using $(HELP.TYPE)
#       help.test.%.all - print all targets using $(HELP.TYPE.all)
#       help.test.%.internal - print details using $(HELP.TYPE.internal)
#           where  %  is the suffix of the Makefile's filename
#
#       TODO:
#          * include Makefile.* should be generic
#          * unify test.warnings.log and test.tests.log (should use same target)
#          * rename ALL.tests and ALL.tests.log (too similar to ALL.test)
#
#? VERSION
#?      @(#) Makefile 1.32 19/01/13 19:50:53
#?
#? AUTHOR
#?      18-apr-18 Achim Hoffmann
#?
# -----------------------------------------------------------------------------

_SID.test       = 1.32

_MYSELF.test    = t/Makefile
ALL.includes   += $(_MYSELF.test)
ALL.inc.type   += test
                # this is the parent makefile in the directory

first-test-target-is-default: help.test

ifndef ALL.Makefiles
    -include t/Makefile.inc
    # defines macros if called directly (not from ../Makefile)
endif

ifeq (,$(_SID.help))
    -include    Makefile.help
    -include ../Makefile.help
    # it's intended that only one will be found
endif

#_____________________________________________________________________________
#___________________________________________________________ default target __|

help.test: help.HEAD
	@echo $(ALL.help.test)

help.test.all:
	@echo " # individual targets for tests"
	@$(MAKE) -s echo=ALL.tests     echo
	@echo ""
	@echo " # targets which write results to logfiles"
	@$(MAKE) -s echo=ALL.tests.log echo
	@echo ""
	@echo " # for more target and details, following targets can be used"
	@echo $(foreach target,$(ALL.inc.type),t-$(target))

.PHONY: help.test help.test.all

# FIXME: some of above HELP-* should be extracted from t/Makefile.*

# FIXME: missing public (not internal) documentation for pattern rules:
#       message-%:
#       no.message-%:
#       testarg0-%:
#       testcmd-%
#       test.all-%:

#_____________________________________________________________________________
#____________________________________________ target for help in t/Makefile*__|

help.test.%: help.HEAD
	@$(TARGET_VERBOSE)
	@echo $(HELP.$*)

help.test.%.all:
	@echo " # individual targets for testing $* :"
	@echo $(ALL.test.$*)
	@echo ""
	@echo $(HELP.$*.all)

help.test.%.internal:
	@echo " # TEST.file:       $(TEST.file)"
	@echo " # TEST.init.$*:    $(TEST.init.$*)"
	@echo " # TEST.$*.hosts:   $(TEST.$*.hosts)"
	@echo " # ALL.test$*:     $(words $(ALL.test$*))  : $(ALL.test$*)"
	@echo " # ALL.test.$*:    $(words $(ALL.test.$*)) : $(ALL.test.$*)"
	@echo $(HELP.$*.internal)
	@echo " # -------------------------------------------------------------"

# TODO:  some alias because suffix differs from type
help.test.cmd.all:     help.test.cmds.all
help.test.warning.all: help.test.warnings.all
help.test.cmd.internal:     help.test.cmds.internal
help.test.warning.internal: help.test.warnings.internal

help-test-all       = $(foreach type,$(ALL.inc.type), help.test.$(type).all)
help-test-internal  = $(foreach type,$(ALL.inc.type), help.test.$(type).internal)
help.test.targets:
	@$(MAKE) -s $(help-test-all) $(help-test-internal)

.PHONY: help.test.targets


#_____________________________________________________________________________
#________________________________________________________________ variables __|

# store -n (dry-run) option in own variable
_n := $(if $(findstring n,$(firstword -$(MAKEFLAGS))),-n)

# test tools (part of distribution)
TEST.dir        = t
TEST.logdir     = $(TEST.dir)/log

# following may be redefined in included t/Makefiles*
# TEST.init       = --header
# TEST.args       =

# macro for list of hostnames needs to be unique in each Makefile*
# otherwise some targets in other Makefile* get confused
#TEST.host       = localhost
#TEST.hosts      =

# following defined in ../Makefile
# TEST.do  =
# SRC.test =
# ALL.test =

# defined in other t/Makefile*
# ALL.tests =

OPT.grep        = -q
    # grep (mainly used in message-% target) should not report matching lines
    # macro can be reset or redifined for more verbose output

# internal used tools and files (paths hardcoded!)
EXE.bench       = t/o-saft_bench
EXE.test.bunt   = t/test-bunt.pl.txt

_TODAY_         = $(shell date +%Y""%m%d)

HELP.test       = " \
\# Following variables are intended to be used on command line:$(_NL)\
\#$(_NL)\
\#   EXE.pl      - program to perform tests, default: $(EXE.pl)$(_NL)\
\#   TEST.init   - arguments and options always passed to EXE.pl; default: $(TEST.init)$(_NL)\
\#   TEST.args   - arguments and options to be passed to EXE.pl per target$(_NL)\
\#   TEST.host   - hostname to be used for tests (when only one is expected)$(_NL)\
\#   TEST.hosts  - list of hostnames to perform tests with$(_NL)\
\#   TEST.dir    - directory in which EXE.pl will be executed; default: $(TEST.dir)$(_NL)\
\#   TEST.logdir - directory where results of EXE.pl will be stored; default: $(TEST.logdir)$(_NL)\
\#   TEST.rc     - content of RC-file to be used by EXE.pl: $(TEST.rc)$(_NL)\
\#$(_NL)\
\# Keep in mind that following files are located in $(TEST.dir):$(_NL)\
\#   .o-saft.pl  $(TEST.rc)  .o-saft.tcl$(_NL)\
\# which are used by EXE.pl or other tools used for the tests.$(_NL)\
"
#  $(SRC.rc)  may not be defined here, hence hardcoded

ALL.help.test   += $(_NL)$(HELP.test)

#_____________________________________________________________________________
#_____________________________________________________ internal test target __|

# internal information (nothing related to $(Project))
# Note that the $(_SID*) variables indicate if a sub-makefile was included.
# Note that $$ neds to be used to ensure that the variables are evaluated when
#      the targets executes and not when the Makefile is read.
test.file-1:
test,file-2:
test_file-3:
test.target: test.file-1 test,file-2 test_file-3
	@echo 'test.target: test.file-1 test-file-2 test_file-3'
	@echo '# SIDs of included Makefile* (file not included if SID missing):'
	@echo '# $$(_SID)          = $(_SID)'
	@echo '# $$(_SID.help)     = $(_SID.help)'
	@echo '# $$(_SID.test)     = $(_SID.test)'
	@echo '# $$(_SID.critic)   = $(_SID.critic)'
	@echo '# $$(_SID.warnings) = $(_SID.warnings)'
	@echo '# $$(_SID.exit)     = $(_SID.exit)'
	@echo '# $$(_SID.misc)     = $(_SID.misc)'
	@echo '# $$(_SID.cmds)     = $(_SID.cmds)'
	@echo '# $$(_SID.ext)      = $(_SID.ext)'
	@echo '# $$(_SID.cgi)      = $(_SID.cgi)'
	@echo '# $$(_SID.hlp)      = $(_SID.hlp)'
	@echo '# $$(_SID.inc)      = $(_SID.inc)'
	@echo '# $$(_SID.opt)      = $(_SID.opt)'
	@echo '# $$(_SID.tcl)      = $(_SID.tcl)'
	@echo '# show some private make variables:'
	@echo '# $$(PWD)           = $(PWD)'
	@echo '# $$(PWD.dir)       = $(notdir $(PWD))'
	@echo '# $$(TEST.dir)      = $(TEST.dir)'
	@echo '# $$(TEST.logdir)   = $(TEST.logdir)'
	@echo '# $$(TEST.host)     = $(TEST.host)'
	@echo '# $$(TEST.hosts)    = $(TEST.hosts)'
	@echo '# $$(ALL.Makefiles) = $(ALL.Makefiles)'
	@echo '# $$(ALL.includes)  = $(ALL.includes)'
	@echo '# show some make variables:'
	@echo '# $$@    = $@ #'
	@echo '# $$<    = $< #'
	@echo '# $$?    = $? #'
	@echo '# $$^    = $^ #'
	@echo '# $$+    = $+ #'
	@echo '# $$|    = $| #'
	@echo '# $$%    = $% #'
	@echo '# $$*    = $* #'
	@echo '# $$>    = $> #'
	@echo '# $$-    = $- #'
	@echo '# $$D    = $D #'
	@echo '# $$F    = $F #'
	@echo '# $$(MAKE)          = $(MAKE)'
	@echo '# $$(CURDIR)        = $(CURDIR)'
	@echo '# $$(MAKE_COMMAND)  = $(MAKE_COMMAND)'
	@echo '# $$(MAKE_VERSION)  = $(MAKE_VERSION)'
	@echo '# $$(MAKE_HOST)     = $(MAKE_HOST)'
	@echo '# $$(MAKELEVEL)     = $(MAKELEVEL)'
	@echo '# $$(MAKEFILE)      = $(MAKEFILE)'
	@echo '# $$(MAKEFILES)     = $(MAKEFILES)'
	@echo '# $$(MAKEFILE_LIST) = $(MAKEFILE_LIST)'
	@echo '# $$(MAKEFILE_LIST)F= $(firstword $(MAKEFILE_LIST))'
	@echo '# $$(MAKEFILE_LIST)L= $(lastword  $(MAKEFILE_LIST))'
	@echo '# $$(MFLAGS)        = $(MFLAGS)'
	@echo '# $$(MAKEFLAGS)     = $(MAKEFLAGS)'
	@echo '# $$(MAKEOVERRIDES) = $(MAKEOVERRIDES)'
	@echo '# $$(MAKECMDGOALS)  = $(MAKECMDGOALS)'
	@echo '# $$(GNUMAKEFLAGS)  = $(GNUMAKEFLAGS)'
	@echo '# $$(.PRECIOUS)     = $(.PRECIOUS)'
	@echo '# $$(.SECONDARY)    = $(.SECONDARY)'
	@echo '# $$(.INTERMEDIATE) = $(.INTERMEDIATE)'
	@echo '# $$(.SUFFIXES)     = $(.SUFFIXES)'
	@echo '# $$(.VARIABLES)    = $(.VARIABLES)'

#_____________________________________________________________________________
#______________________________________________________ targets for testing __|

# target to check for empty hostname list, can also be used for more debugging
_no-hosts__not-yet-working:
	@[ "$(eTEST.hosts)" = "" ] && $(eval _ERR := "no TESTS.hosts defined")
	@[ "$(eTEST.hosts)" = "from.Makefile.FQDN" ] \
		&& $(eval _ERR := "fake TESTS.hosts defined in $(TEST.file)")
	@[ -n "$(_ERR)" ] && echo $(_ERR) && exit 2  || echo -n ""

_no-hosts:
	@-[ "$(eTEST.hosts)" = "" ] \
		&& echo no TESTS.hosts defined \
		&& exit 2 \
		|| echo -n ""
	@-[ "$(eTEST.hosts)" = "from.Makefile.FQDN" ] \
		&& echo fake TESTS.hosts defined in $(TEST.file) \
		&& exit 2 \
		|| echo -n ""

.PHONY: _no-hosts

$(TEST.logdir):
	@mkdir $@


# Testing for messages or other strings (i.e **WARNING) works as follows:
#   call $(EXE.pl) with command and/or options in question
#   then search (grep) output for message (string)
# For some behaviours of $(EXE.pl) a RC-file is required.
# Different target rules can be mapped to the pattern rule message-%. It gets
# the message string  from the automatic variable  $* , and all arguments for
# $(EXE.pl) with following Makefile variables:
#   $(TEST.init)    - command, options to be passed to $(EXE.pl)
#   $(TEST.args)    - command, options and hostname to be passed to $(EXE.pl)
#   $(TEST.rc)      - content of RC-file to be used by $(EXE.pl)
# These variables can be set conditinally for each target, see example below.
# Some tests are not yet implemented, or difficult to implement. In this case
# $(TEST.args) contains a string starting with "TODO:". The  message-% target
# tests the variable for this string and then simply prints it. Otherwise the
# check will be performed (see  if - else - fi  in message-% rule).
# The pattern rule succeeds (returns status 0)  if the pattern is found.  The
# rule fails, if the pattern is not found. That's why it is very important to
# define  TEST.args  propperly. Even the sequence of the arguments may count.
#
# Note:  even  _TMP.rc  is generated for each call, it will only be used when
# requested with the  --rc=$(_TMP.rc)  option.
# Note:  if  TEST.args  contains special characters, syntax errors may occour
# when used in the shell. Quoting  TEST.args  is not possible because then it

=== debian/changelog ===
o-saft (19.01.19-3) unstable; urgency=medium

  * d/{control|copyright}: Update upstream URL (closes: #968985)

 -- Samuel Henrique <samueloph@debian.org>  Thu, 11 Feb 2021 00:04:34 +0000

o-saft (19.01.19-2) unstable; urgency=medium

  [ Samuel Henrique ]
  * Bump DH to 13
  * Bump Standards-Version to 4.5.1
  * Add salsa-ci.yml
  * Configure git-buildpackage for Debian
  * d/control: Add Rules-Requires-Root: no

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.4.1, no changes needed.
  * Update standards version to 4.5.0, no changes needed.

 -- Samuel Henrique <samueloph@debian.org>  Fri, 29 Jan 2021 19:48:57 +0000

o-saft (19.01.19-1) unstable; urgency=medium

  * New upstream version 19.01.19
  * Bump DH level to 12
  * Bump Standards-Version to 4.3.0
  * Refresh patches

 -- Samuel Henrique <samueloph@debian.org>  Tue, 29 Jan 2019 19:36:25 +0000

o-saft (18.11.18-1) unstable; urgency=medium

  * New upstream version 18.11.18
  * d/copyright: use https
  * d/o-saft.install: reflect filename change
  * d/p/tests: update patch
  * d/p/makefile: update patch

 -- Samuel Henrique <samueloph@debian.org>  Thu, 06 Dec 2018 23:16:38 +0000

o-saft (18.07.18-1) unstable; urgency=medium

  * New upstream version 18.07.18
  * d/control: add openssl dependency
  * d/o-saft.install: reflect new upstream location of o-saft_bench
  * d/t/control: better test command and mark as superficial

 -- Samuel Henrique <samueloph@debian.org>  Wed, 31 Oct 2018 00:17:53 -0300

o-saft (17.09.17-2) unstable; urgency=high

  * Revert "symlink on /usr/bin instead of using helper script"
    (closes: #911402)

 -- Samuel Henrique <samueloph@debian.org>  Sat, 20 Oct 2018 01:19:31 -0300

o-saft (17.09.17-1) unstable; urgency=medium

  * Initial Debian release (closes: #905998)
  * Bump DH to 11
  * Bump Standards-Version to 4.2.0
  * Bump watch to v4
  * Move maintenance to Security Tools Packaging Team
  * Don't ship perlcriticrc, .pod file and unneeded pdf
  * Symlink on /usr/bin instead of using helper script
  * d/control: set priority to optional, was extra
  * d/copyright: update file
  * d/o-saft.lintian-overrides:
     - add lintian-override for dockerfile
  * d/rules:
    - don't make Dockerfile executable
    - remove template comments and trailing whitespace
  * wrap-and-sort -a

 -- Samuel Henrique <samueloph@debian.org>  Mon, 13 Aug 2018 12:07:25 -0300

o-saft (17.09.17-0kali1) kali-dev; urgency=medium

  * Import new upstream release

 -- Sophie Brun <sophie@freexian.com>  Mon, 09 Oct 2017 07:03:12 +0200

o-saft (15.11.15-0kali1) kali-dev; urgency=medium

  * Import new upstream release
  * Use debhelper 9
  * Update debian files
  * Install the file for bash completion

 -- Sophie Brun <sophie@freexian.com>  Tue, 15 Dec 2015 15:27:29 +0100

o-saft (14.1.4-0kali1) kali; urgency=low

  * Initial release (Closes: 0000827)

 -- Devon Kearns <dookie@kali.org>  Wed, 12 Feb 2014 12:35:06 -0700

=== debian/control ===
Source: o-saft
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Samuel Henrique <samueloph@debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 13)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://owasp.org/www-project-o-saft/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/o-saft
Vcs-Git: https://salsa.debian.org/pkg-security-team/o-saft.git

Package: o-saft
Architecture: all
Depends: libio-socket-ssl-perl,
         libnet-dns-perl,
         libnet-ssleay-perl,
         libreadonly-perl,
         openssl,
         perl,
         ${misc:Depends}
Recommends: libperl-critic-perl,
            tk (>= 8.5)
Description: SSL advanced forensic tool
 O-Saft is an easy to use tool to show information about SSL certificates and
 tests the SSL connection according to a given list of ciphers and various SSL
 configurations.
 .
 It's designed to be used by penetration testers, security auditors or server
 administrators. The idea is to show the important information or the special
 checks with a simple call of the tool. However, it provides a wide range of
 options so that it can be used for comprehensive and special checks by
 experienced people.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_fixperms:
	dh_fixperms
	chmod 644 debian/o-saft/usr/share/doc/o-saft/examples/*
	chmod 755 debian/o-saft/usr/share/o-saft/o-saft-img.tcl

override_dh_auto_install:
	dh_auto_install
	dh_bash-completion

override_dh_installexamples:
	dh_installexamples -Xbash_completion

=== debian/watch ===
version=4
opts="filenamemangle=s/.*\/(.*)\.tar\.gz/o-saft-$1.tar.gz/" \
https://github.com/OWASP/O-Saft/tags .*/(.*)\.tar\.gz

## o-saft 22.02.22

=== Makefile ===
#! /usr/bin/make -rRf
#?
#? NAME
#?      Makefile        - makefile for O-Saft project
#?
#? SYNOPSYS
#?      make [options] [target] [...]
#?
#? DESCRIPTION
#?      For help about the targets herein, please see:
#?
#?          make
#?          make help
#?
#?      For detailled documentation how GNU Make, its syntax and conventions as
#?      well as some special syntax of macros and targets is used here,  please
#?      refer to  Makefile.pod , for example by using  "perldoc Makefile.pod" .
#?      The term  "SEE Make:some text"  is used to reference to Makefile.pod .
#
# HACKER's INFO
#       For the public available targets see below of  "well known targets" .
#?
#? VERSION
#?      @(#) Makefile 1.123 22/02/27 22:48:36
#?
#? AUTHOR
#?      21-dec-12 Achim Hoffmann
#?
# -----------------------------------------------------------------------------

_SID            = 1.123
                # define our own SID as variable, if needed ...
                # SEE O-Saft:Makefile Version String
                # Known variables herein (8/2019) to be changed are:
                #     _SID
                #     _INST.text
                #     GREP_EDIT

ALL.includes   := Makefile
                # must be  :=  to avoid overwrite after includes
                # each $(TEST.dir)/Makefile* will add itself to ALL.includes

MAKEFILE        = Makefile
                # define variable for myself,  this allows to use  some targets
                # within other makefiles
                # Note that  $(MAKEFILE) is used where any Makefile is possible
                # and  Makefile  is used when exactly this file is meant.
                # $(ALL.Makefiles) is used, when all Makefiles are needed.

MAKEFLAGS       = --no-builtin-variables --no-builtin-rules
.SUFFIXES:

.DEFAULT:
	@echo "**ERROR: unknown target '$(MAKECMDGOALS)'"

first-target-is-default: help

#_____________________________________________________________________________
#________________________________________________________________ variables __|

Project         = o-saft
ProjectName     = O-Saft
INSTALL.dir     = /usr/local/$(Project)

# tool source files
SRC.lic         = yeast.lic
DEV.pl          = yeast.pl
CHK.pl          = checkAllCiphers.pl
OSD.dir         = OSaft/Doc
OSD.pm          = OSaft/Doc/Data.pm
OSD.txt         = \
		  coding.txt \
		  glossary.txt \
		  help.txt \
		  links.txt \
		  misc.txt \
		  rfc.txt \
		  tools.txt
SRC.txt         = $(OSD.txt:%=$(OSD.dir)/%)
NET.pm          = SSLinfo.pm \
		  SSLhello.pm
_CIPHER         = \
		  _ciphers_osaft.pm \
		  _ciphers_iana.pm \
		  _ciphers_openssl_all.pm \
		  _ciphers_openssl_low.pm \
		  _ciphers_openssl_medium.pm \
		  _ciphers_openssl_high.pm
# add to SRC.pm  $(_CIPHER:%=OSaft/%)  when used
OSAFT.pm        = Ciphers.pm error_handler.pm
USR.pm          = \
		  $(Project)-dbx.pm \
		  $(Project)-man.pm \
		  $(Project)-usr.pm
SRC.pm          = \
		  osaft.pm \
		  $(NET.pm:%=Net/%)   \
		  $(OSAFT.pm:%=OSaft/%) \
		  $(USR.pm) \
		  $(OSD.pm)
SRC.sh          = $(Project)
SRC.pl          = $(Project).pl
SRC.tcl         = $(Project).tcl
SRC.gui         = $(Project).tcl $(Project)-img.tcl
SRC.cgi         = $(Project).cgi
SRC.php         = $(Project).php
SRC.docker      = \
		  $(Project)-docker \
		  $(Project)-docker-dev \
		  Dockerfile
SRC.rc          = .$(SRC.pl)

SRC.make        = Makefile
SRC.misc        = README CHANGES
SRC.inst        = $(SRC.contrib.dir)/INSTALL-template.sh

# contrib files
SRC.contrib.dir     = contrib
SRC.contrib.examples= filter_examples usage_examples
SRC.contrib.post.awk= \
		  Cert-beautify.awk \
		  HTML-simple.awk   HTML-table.awk \
		  JSON-struct.awk   JSON-array.awk \
		  XML-attribute.awk XML-value.awk \
		  lazy_checks.awk
SRC.contrib.post    = \
		  Cert-beautify.pl \
		  alertscript.pl \
		  alertscript.cfg \
		  bunt.pl \
		  bunt.sh \
		  symbol.pl
SRC.contrib.misc    = \
		  cipher_check.sh \
		  critic.sh \
		  gen_standalone.sh \
		  distribution_install.sh \
		  install_openssl.sh \
		  install_perl_modules.pl \
		  INSTALL-template.sh \
		  Dockerfile.alpine-3.6

SRC.contrib.zap     = zap_config.sh zap_config.xml
# some file should get the $(Project) suffix, which is appended later
SRC.contrib.complete= \
		  bash_completion \
		  dash_completion \
		  fish_completion \
		  tcsh_completion
SRC.contrib     = \
		  $(SRC.contrib.complete:%=$(SRC.contrib.dir)/%_$(Project)) \
		  $(SRC.contrib.examples:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.post.awk:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.post:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.misc:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.zap:%=$(SRC.contrib.dir)/%)

# test files
TEST.dir        = t
TEST.logdir     = $(TEST.dir)/log
TEST.do         = SSLinfo.pl \
                  o-saft_bench.sh \
                  cloc-total.awk \
                  critic_345.sh \
                  test-bunt.pl.txt
TEST.critic.rc  = .perlcriticrc
SRC.test        = \
                  $(TEST.do:%=$(TEST.dir)/%) \
                  $(TEST.critic.rc:%=$(TEST.dir)/%)

# documentation files
DOC.dir         = docs
DOC.src         = o-saft_CLI_data_flow.odg \
		  o-saft_GUI_data_flow.odg \
		  o-saft_docker.de.odg \
		  o-saft_docker.en.odg
SRC.doc         = $(DOC.src:%=$(DOC.dir)/%)
WEB.dir         = docs/img
WEB.src         = \
		  img.css \
		  O-Saft_CLI-cipher.png \
		  O-Saft_CLI-altname.png \
		  O-Saft_GUI-altname.png \
		  O-Saft_GUI-check.png \
		  O-Saft_GUI-cmd--docker.png \
		  O-Saft_GUI-cmd.png \
		  O-Saft_GUI-cmd-0.png \
		  O-Saft_GUI-filter.png \
		  O-Saft_GUI-help-0.png \
		  O-Saft_GUI-help-1.png \
		  O-Saft_GUI-opt.png \
		  O-Saft_GUI-prot.png \
		  O-Saft_GUI-vulns.png \
		  O-Saft_CLI-vulns.png \
		  O-Saft_CLI__faked.txt
SRC.web         = $(WEB.src:%=$(WEB.dir)/%)

# generated files
TMP.dir         = /tmp/$(Project)
GEN.html        = $(DOC.dir)/$(Project).html
GEN.cgi.html    = $(DOC.dir)/$(Project).cgi.html
GEN.text        = $(DOC.dir)/$(Project).txt
GEN.wiki        = $(DOC.dir)/$(Project).wiki
GEN.man         = $(DOC.dir)/$(Project).1
GEN.pod         = $(DOC.dir)/$(Project).pod
GEN.src         = $(SRC.contrib.dir)/$(Project)-standalone.pl
GEN.pdf         = $(SRC.doc:%.odg=%.pdf)
GEN.inst        = INSTALL.sh
GEN.tags        = tags
GEN.rel         = $(Project).rel

GEN.tgz         = $(Project).tgz
GEN.tmptgz      = $(TMP.dir)/$(GEN.tgz)

# generated files for internal use, i.e. $(SRC.tcl)
# TODO: because make does not allow = in target names, the generated targets
#       should use - instead
_HELP.opt_data  = +help --help=opt --help=commands --help=glossar --help=alias \
		  --help=data --help=checks --help=regex --help=rfc \
                  --help=warnings
GEN.DOC.data    = $(_HELP.opt_data:%=$(DOC.dir)/$(SRC.pl).%)

# summary variables
GEN.docs        = $(GEN.pod) $(GEN.html) $(GEN.cgi.html) $(GEN.text) $(GEN.wiki) $(GEN.man)
SRC.exe         = $(SRC.pl)  $(SRC.gui) $(CHK.pl)  $(DEV.pl) $(SRC.sh)
SRC.Makefiles   = \
		  Makefile         Makefile.inc   Makefile.help  Makefile.pod \
		  Makefile.opt     Makefile.cmd   Makefile.ext   Makefile.exit \
		  Makefile.cgi     Makefile.tcl   Makefile.misc  Makefile.warnings \
		  Makefile.critic  Makefile.dev   Makefile.etc   Makefile.template \
		  Makefile.docker  Makefile.FQDN  Makefile.examples
# NOTE: sequence in ALL.Makefiles is important, for example when used in target doc
ALL.Makefiles   = $(SRC.make) $(SRC.Makefiles:%=$(TEST.dir)/%)
ALL.osaft       = $(SRC.pl)  $(SRC.gui) $(CHK.pl)  $(SRC.pm)  $(SRC.sh) $(SRC.txt) $(SRC.rc) $(SRC.docker)
ALL.exe         = $(SRC.exe) $(SRC.cgi) $(SRC.php) $(GEN.src) $(SRC.docker)
ALL.tst         = $(SRC.test)
ALL.contrib     = $(SRC.contrib)
ALL.doc         = $(SRC.doc) $(SRC.web)
ALL.pm          = $(SRC.pm)
ALL.gen         = $(GEN.src) $(GEN.pod) $(GEN.html) $(GEN.cgi.html) $(GEN.text) $(GEN.man) $(GEN.inst) $(GEN.DOC.data)
ALL.docs        = $(SRC.doc) $(GEN.docs)
    # NOTE: ALL.docs are the files for user documentation, ALL.doc are SRC-files
#               # $(GEN.tags) added in t/Makefile.misc
#               # $(GEN.wiki) not part of ALL.gen as rarly used
ALL.src         = \
		  $(ALL.exe) \
		  $(ALL.pm) \
		  $(SRC.txt) \
		  $(SRC.rc) \
		  $(SRC.misc) \
		  $(SRC.doc) \
		  $(ALL.gen) \
		  $(ALL.Makefiles) \
		  $(ALL.tst) \
		  $(ALL.contrib)
ALL.tgz         = $(ALL.src:%=O-Saft/%)

# internal used make
MAKE            = $(MAKE_COMMAND)
# some rules need to have a command, otherwise they are not evaluated
EXE.dummy       = /bin/echo -n ""
# internal used tools (paths hardcoded!)
EXE.single      = contrib/gen_standalone.sh
EXE.docker      = o-saft-docker
EXE.pl          = $(SRC.pl)
#                   SRC.pl is used for generating a couple of data

# other tools
EXE.office      = libreoffice

# summary variables (mainly used for INSTALL.sh)
_ALL.devtools.intern  += $(EXE.single)
_ALL.devtools.extern  += sccs gpg sha256sum docker
ALL.tools.optional     = aha perldoc pod2html pod2man pod2text pod2usage podman podviewer tkpod stty tput
ALL.devtools    = $(_ALL.devtools.intern)   $(_ALL.devtools.extern)
ALL.devmodules  = $(_ALL.devmodules.intern) $(_ALL.devmodules.extern)

# INSTALL.sh must not contain duplicate files, hence the variable's content
# is sorted using make's built-in sort which removes duplicates
_INST.osaft_cgi = $(sort $(SRC.cgi) $(SRC.php) $(GEN.cgi.html))
_INST.osaft_doc = $(sort $(GEN.pod) $(GEN.man) $(GEN.html))
_INST.contrib   = $(sort $(ALL.contrib))
_INST.osaft     = $(sort $(ALL.osaft))
_INST.devtools  = $(sort $(ALL.devtools))
_INST.tools_int = $(sort $(_ALL.devtools.intern))
_INST.tools_ext = $(sort $(_ALL.devtools.extern))
_INST.tools_opt = $(sort $(ALL.tools.optional))
_INST.tools_other = $(sort $(ALL.tools.ssl))
_INST.devmodules= $(sort $(ALL.devmodules))
_INST.text      = generated from Makefile 1.123
EXE.install     = sed   -e 's@INSERTED_BY_MAKE_INSTALLDIR@$(INSTALL.dir)@'    \
			-e 's@INSERTED_BY_MAKE_CONTRIBDIR@$(SRC.contrib.dir)@'    \
			-e 's@INSERTED_BY_MAKE_CONTRIB@$(_INST.contrib)@'     \
			-e 's@INSERTED_BY_MAKE_TOOLS_OTHER@$(_INST.tools_other)@' \
			-e 's@INSERTED_BY_MAKE_TOOLS_OPT@$(_INST.tools_opt)@' \
			-e 's@INSERTED_BY_MAKE_DEVTOOLSINT@$(_INST.tools_int)@' \
			-e 's@INSERTED_BY_MAKE_DEVTOOLSEXT@$(_INST.tools_ext)@' \
			-e 's@INSERTED_BY_MAKE_DEVMODULES@$(_INST.devmodules)@' \
			-e 's@INSERTED_BY_MAKE_OSAFT_SH@$(SRC.sh)@'           \
			-e 's@INSERTED_BY_MAKE_OSAFT_PL@$(SRC.pl)@'           \
			-e 's@INSERTED_BY_MAKE_OSAFT_GUI@$(SRC.tcl)@'         \
			-e 's@INSERTED_BY_MAKE_OSAFT_CGI@$(_INST.osaft_cgi)@' \
			-e 's@INSERTED_BY_MAKE_OSAFT_DOC@$(_INST.osaft_doc)@' \
			-e 's@INSERTED_BY_MAKE_OSAFT@$(_INST.osaft)@'         \
			-e 's@INSERTED_BY_MAKE@$(_INST.text)@'
                # last substitude is fallback to ensure everything is changed

# generate f- targets to print HELP text for each target
_HELP.my_targets= $(shell $(EXE.eval) $(MAKEFILE))
_HELP.alltargets= $(shell $(EXE.eval) $(ALL.includes))
_HELP.help      = $(ALL.help:%=f-%)
                # quick&dirty because each target calls make (see below)

#_____________________________________________________________________________
#___________________________________________________________ default target __|

# define header part of default target
help:           HELP_HEAD = $(HELP_RULE)
help.all:       HELP_HEAD = $(HELP_RULE)
help.log:       HELP_HEAD = $(HELP_RULE)
help.all.log:   HELP_HEAD = $(HELP_RULE)
doc:            HELP_HEAD = $(HELP_RULE)
doc.all:        HELP_HEAD = $(HELP_RULE)

# define body part of default target
# TODO: adapt _help_* macros and targets according own naming convention
_help_also_               = _help_also
_help_body_               = _help_body_me
_help_list_               =
help.all:     _help_body_ = _help_body_all
help.all:     _help_list_ = _help_list
doc:          _help_body_ = _eval_body_me
doc.all:      _help_body_ = _eval_body_all
doc:          _help_also_ =
doc.all:      _help_also_ =

=== t/Makefile ===
#! /usr/bin/make -rRf
#?
#? NAME
#?      Makefile        - makefile for testing O-Saft
#?
#? SYNOPSYS
#?      make [options] [target] [...]
#?
#? DESCRIPTION
#?      For more details please see
#?          ../Makefile  Makefile.help  Makefile.pod
#?      make help.test
#?
# HACKER's INFO
#       For details please see
#           ../Makefile  Makefile.help  Makefile.template
#
#    Naming conventions for t/Makefile*
#       * variable names have the prefix  TEST  and  HELP .
#       * target names for public use have the prefix  test.
#       * individual, special targets have the prefix  _test (exceptions exist)
#
#    Summary variables extended in each t/Makefile*
#       ALL.includes    - list of Makefiles
#       ALL.inc.type    - list of types (should be suffix of Makefile's name)
#       ALL.help.tests  - list of documentation (help) texts
#       ALL.tests       - list of targets for testing
#       ALL.tests.log   - list of targets for testing writing to logfile
#
#    Variables specific for each t/Makefile*
#       _SID.myTYPE     - version number
#       _MYSELF.myTYPE  - name of current file
#       HELP.myTYPE     - documentation (help) text for the corresponding file
#       HELP.myTYPE.all - list of all targets for the corresponding file
#       HELP.myTYPE.internal  - some more documentation (help) text
#           where  myTYPE  above is the suffix of the Makefile's filename
#
#    Each t/Makefile* may also redefine following variables
#       HELP_TYPE       - suffix (and type) of Makefile*
#       HELP_HEAD       - descriptive header line, set to HELP_NAME, HELP_RULE 
#
#    Special targets for documentation (help) in t/Makefile*
#       help.test.%     - print individual documentation using $(HELP.myTYPE)
#       help.test.%.all - print all targets using $(HELP.myTYPE.all)
#       help.test.%.internal - print details using $(HELP.myTYPE.internal)
#           where  %  is the suffix of the Makefile's filename
#
#       TODO:
#          * include Makefile.* should be generic
#          * unify test.warnings.log and test.tests.log (should use same target)
#          * rename ALL.tests and ALL.tests.log (too similar to ALL.test)
#
#? VERSION
#?      @(#) Makefile 1.125 22/02/22 09:27:40
#?
#? AUTHOR
#?      18-apr-18 Achim Hoffmann
#?
# -----------------------------------------------------------------------------

HELP-help.test.test = general testing targets

_SID.test          := 1.125

_MYSELF.test       := t/Makefile
ALL.includes       += $(_MYSELF.test)
ALL.inc.type       += test
ALL.help.tests     += help.test

export OSAFT_MAKE  := avoid writing random data (like date and time string)

ifndef ALL.Makefiles
    -include t/Makefile.inc
    # defines variables if called directly (not from ../Makefile)
endif

first-test-target-is-default: help.test

help.test:            HELP_TYPE = test
help.test-v:          HELP_TYPE = test
help.test-vv:         HELP_TYPE = test
help.test.all:        HELP_TYPE = test
help.test.test:       HELP_TYPE = test
help.test.test-v:     HELP_TYPE = test
help.test.test-vv:    HELP_TYPE = test
help.test.test.all:   HELP_TYPE = test
help.test:            HELP_HEAD = $(HELP_RULE)
help.test.%:          HELP_HEAD = $(HELP_RULE)

#_____________________________________________________________________________
#________________________________________________________________ variables __|

# store -n (dry-run) option in own variable
TEST.make-n    := $(if $(findstring n,$(firstword -$(MAKEFLAGS))),-n)

# internal variables
TEST.dir       := t
TEST.logdir     = $(TEST.dir)/log
TEST.symlinks  := ../contrib ../osaft.pm ../.o-saft.pl ../Net ../docs ../OSaft

# following may be redefined in included t/Makefiles*
#TEST.init      := --header
#TEST.args      :=

# variable for list of hostnames needs to be unique in each Makefile*
# otherwise some targets in other Makefile* get confused
#TEST.host       = localhost
#TEST.hosts      =

# following defined in ../Makefile
# TEST.do  =
# SRC.test =
# ALL.test =

# defined in other t/Makefile*
# ALL.tests =

#  $(SRC.rc)  may not be defined here, hence hardcoded

ifndef SRC.contrib.dir
    SRC.contrib.dir = contrib
endif

# Tracing just the log-targets is special. Using  $(TRACE.target)  is not an
# option, because it would als change the final target called with  $(MAKE) .
# Hence an additional variable is used.
# TODO: not public, not documented, variable needs to be defined here
TRACE.target.log    =
    #  example  = echo "\# $*\tcalling: $(MAKE) -s testcmd-$*"

TEST.today         := $(shell date +%Y""%m%d)
    # current date in ISO format

# need a usable way to change diff program; EXE.diff may be set on command-line
EXE.log-diff       := diff
EXE.log-xxdiff     := xxdiff --geometry 1600x1000
EXE.log-mgdiff     := mgdiff
EXE.log-tkdiff     := tkdiff
EXE.diffs          := diff xxdiff mgdiff tkdiff
EXE.diff           := tkdiff
EXE.log-diff        = $(EXE.log-tkdiff)
    # chaneg EXE.log-diff to use another program

_EXE.grep-opt      := -q
    # grep (mainly used in message-% target) should not report matching lines
    # variable can be reset or redifined for more verbose output

_EXE.sort-opt      := -n -f
    # newer GNU sort (~2018) changed the default behaviour, for example
    # case-sensitivity, these options do the traditional sort
    # TODO: need to check first if sort supports these options

_EXE.perldoc-opt   := -n nroff
    # newer perldoc prints with plain text format by default
    # -n nroff enforced the traditional behaviour with ASCII-escapes

# define script or parts of it as variables, for better human readability
# SEE Make:target matching
#     _EXE.macro_by_line.awk    - extract all variable names
#     _EXE.target_by_line.awk   - extract all target names
#     _EXE.target_to_arr.awk    - extract target names and store uniquely in arr[]
#     _EXE.print_arr_END.awk    - print collected data from arr[]
#     _EXE.print_file.awk       - either print separator line or the filename
TEST.target_prefix :=   [a-zA-Z][_a-zA-Z.]
   # matching target names not starting with _
_EXE.macro_by_line.awk := /^[a-zA-Z_][a-zA-Z_.]* *=/{sub(/=/,"",$$1);print $$1}
_EXE.target_by_line.awk:= /^[a-zA-Z_][a-zA-Z_.]* *:/{sub(/:/,"",$$1);print $$1}
_EXE.target_to_arr.awk  = /^.*%/{next} /^$(TEST.target_prefix)*/{arr[$$1]=1}
_EXE.print_arr_END.awk := END{for(idx in arr){print idx}}
_EXE.print_file.awk    := (FNR==1){ x="";for(i=1;i<62;i++){x=sprintf("%s%c",x,"-")};print "\n\t\t\#"x}

# if target was test*-compare-v or test*-move-v  TRACE.target  is not empty, so
# checking this variable if not empty is sufficent to print verbose information
# not tested if following defines could be written as macros
# SEE Make:defines with commands

define EXE.log-compare
	cd $(TEST.logdir) && \
	echo "# compare "`ls $(TEST.target_prefix)*.log$(TEST.log-suffix) | wc -l`" file ..." && \
	for f in $(TEST.target_prefix)*.log; do \
	    [ -f $${f}$(TEST.log-suffix) ] || continue ; \
	    [ -n '$(TRACE.target)' ] && echo "# $(TEST.logdir)/$${f} ..." ; \
	    $(EXE.log-diff) $${f} $${f}$(TEST.log-suffix) >/dev/null 2>&1 ; \
	done
endef

define EXE.log-compare-hint
	echo ""
	echo "# for informations and to show differences with $(EXE.diff), use:"
	echo "    $(MAKE_COMMAND) help.test.log-info"
	echo "    $(MAKE_COMMAND) $(MAKECMDGOALS)-compare"
	echo "    $(MAKE_COMMAND) $(MAKECMDGOALS)-compare-v"
	echo "    $(MAKE_COMMAND) $(MAKECMDGOALS)-compare TEST.log-suffix=$(TEST.log-suffix)"
endef

define EXE.log-move
	cd $(TEST.logdir) && \
	for f in $(TEST.target_prefix)*.log; do \
	    [ -f $${f}$(TEST.log-suffix) ] || continue ; \
	    [ -n '$(TRACE.target)' ] && echo "# $(TEST.logdir)/$${f} ..." ; \
	    mv $${f}$(TEST.log-suffix) $${f} ; \
	done
endef

# FIXME: does not set _stub properly if $* is set
define EXE.log-move-hint
	_stub="log"
	$(eval _stub="log")
	$(eval $(shell [ -n "$*" ] && _stub="$*.log" ))
	echo ""
	echo "# for informations and to move new files to .log , use:"
	echo "    $(MAKE_COMMAND) help.test.log-info"
	echo "    $(MAKE_COMMAND) test.$(_stub)-move"
	echo "    $(MAKE_COMMAND) test.$(_stub)-move TEST.log-suffix=$(TEST.log-suffix)"
endef


HELP.test       = $(_NL)\
\# The term '%'  in the targets names described here, may be any of:$(_NL)\
\#   $(ALL.inc.type)$(_NL)\
\#$(_NL)\
\# Following variables are intended to be used on command line:$(_NL)\
\#   EXE.pl      - program to perform tests, default: '$(EXE.pl)'$(_NL)\
\#   TEST.init   - arguments and options always passed to EXE.pl; default: '$(TEST.init)'$(_NL)\
\#   TEST.args   - arguments and options to be  passed to EXE.pl per target$(_NL)\
\#   TEST.host   - hostname to be used for tests (when only one is expected)$(_NL)\
\#   TEST.hosts  - list of hostnames to perform tests with$(_NL)\
\#   TEST.dir    - directory in which EXE.pl will be executed; default: '$(TEST.dir)/'$(_NL)\
\#   TEST.logdir - directory where results of EXE.pl will be stored; default: '$(TEST.logdir)/'$(_NL)\
\#   TEST.rc     - content of RC-file to be used by EXE.pl: '$(TEST.rc)'$(_NL)\
\#   TEST.target_prefix - prefix of log-filename; see help.test.log-info$(_NL)\
\#   TEST.log-suffix    - suffix of log-filename; see help.test.log-info$(_NL)\
\#$(_NL)\
\# Notes about some spezial targets:$(_NL)\
\#   help.test   - automatically generated target; alias for help.test.test$(_NL)\
\#   help.test.test.alls -$(_NL)\
\#   help.test.test.all - be prepared for huge output$(_NL)\
\#$(_NL)\
\# Keep in mind that following files are located in '$(TEST.dir)/':$(_NL)\
\#   .o-saft.pl  $(TEST.rc)  .o-saft.tcl$(_NL)\
\# which are used by EXE.pl or other tools used for the tests.

# following variable contains (huge) list of all available targets
HELP.test.test.all  = $(_NL)\
\# $(words $(ALL.tests)) targets for tests:$(_NL)\
$(ALL.tests)$(_NL)\
\#$(_NL)\
\# $(words $(ALL.tests.log)) targets which write results to logfiles:$(_NL)\
$(ALL.tests.log)$(_NL)\
\#$(_NL)\
\# summary targets for tests:$(_NL)\
$(ALL.help.tests:help.%=%)$(_NL)\
\#$(_NL)\
\# for more target and details, following targets can be used$(_NL)\
$(foreach target,$(ALL.inc.type),t-$(target))$(_NL)

HELP.test.test  = $(HELP.test)
HELP.test.all   = $(HELP.test.test.all)
help.test:          help.test.test
help.test.all:      help.test.test.all
	@$(TRACE.target)
# convenience to satisfy  help.test.all

# help.test.test would only print the HELP-* texts from herein.
# All other tests from the individual t/Makefile.*  files have their own HELP-*
# variable their. help.test.test should also print hints how to get information
# about these other targets. Therefore the auxiliary target  _help_list  exists
# in  Makefile  which is used as dependency here.
help.test.test:     _help_list
help.test.test-v:   _help_list
help.test.test-v-v: _help_list

#_____________________________________________________________________________
#____________________________________________ target for help in t/Makefile*__|

HELP-help.test.test.all     = print available targets for tests from all Makefiles
HELP-help.test.test.alls    = print available targets for tests one per line
#HELP-help.test.test.all-n   = show command for all available test targets
HELP-help.test.%.all        = print available individual targets for tests '%' from Makefile.*

# experimental: some targets print too many shell commands
help.test.test.all-n:
	@$(TRACE.target)
	@$(MAKE) -n $(ALL.tests)

help.test.test.alls:
	@$(TRACE.target)
	@echo " # $(words $(ALL.tests)) targets for tests:"
	@echo $(ALL.tests) | $(EXE.wordperline) | sort $(_EXE.sort-opt)
	@echo ""

help.test.%.all:
	@$(TRACE.target)
	@echo " # individual targets for testing $* :"
	@echo $(ALL.test.$*) | $(EXE.wordperline) | sort $(_EXE.sort-opt)
	@echo ""
	@echo "$(HELP.test.$*.all)"

HELP-help.test.%.internal   = show settings for tests '%' from Makefile.*
help.test.%.internal:
	@$(TRACE.target)
	@echo " # TEST.file:       $(TEST.file)"
	@echo " # TEST.init.$*:    $(TEST.init.$*)"

=== debian/changelog ===
o-saft (22.02.22-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Update standards version to 4.6.0, no changes needed.

  [ Samuel Henrique ]
  * New upstream version 22.02.22
  * Commit all 22.02.22-1 changes at once :(
    - The whole packaging of o-saft had to be refactored as I didn't have
      enough experience to do it right the first time. This is an improved
      version of the packaging with hopefully no regressions.
      I don't have the time to split the changes into different commits or
      changelog entries (and our time is valuable), so here are the big
      changes:
    - Stop installing upstream's contrib files, there's a lot of things
      there and I don't think there's anyone using it.
    - Stop relying on Makefile for packaging, we only need to call the
      install script. This allows me to remove most of the previous
      patches. Two new patches were needed for this, but they will be
      much more simple to maintain.
    - Add a dependency on ca-certificates

 -- Samuel Henrique <samueloph@debian.org>  Thu, 10 Mar 2022 23:42:15 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Samuel Henrique <samueloph@debian.org>
 Build-Depends: bash-completion,
                debhelper-compat (= 13)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://owasp.org/www-project-o-saft/
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/o-saft
@@ -13,7 +13,8 @@
 
 Package: o-saft
 Architecture: all
-Depends: libio-socket-ssl-perl,
+Depends: ca-certificates,
+         libio-socket-ssl-perl,
          libnet-dns-perl,
          libnet-ssleay-perl,
          libreadonly-perl,
